#include <stdio.h>
#include <stdlib.h>
#include <dos.h>


char *getascii(unsigned int in_data[], int off_start, int off_end)
{
    static char ret_val[255];
    int loop, loop1;

    for (loop = off_start, loop1 = 0; loop <= off_end; loop++) {
	ret_val[loop1++] = (char) (in_data[loop] / 256);
	ret_val[loop1++] = (char) (in_data[loop] % 256);
    }
    ret_val[loop1] = '\0';
    return (ret_val);
}

void main(void)
{
    unsigned int dd[256];
    unsigned int dd_off;
    unsigned int loop = 0;
    union REGS registers;
    int num_drv = 0;
    char temp[200];

    num_drv = peekb(0x40, 0x75);
    if (!num_drv) {
	printf("Sistemde hard disk bulunamadi!\n\a");
	exit(1);
    }
    while (inp(0x1F7) != 0x50);
    outp(0x1F6, (loop == 0 ? 0xA0 : 0xB0));
    outp(0x1F7, 0xEC);
    while (inp(0x1F7) != 0x58);
    for (dd_off = 0; dd_off != 256; dd_off++)
	dd[dd_off] = inpw(0x1F0);
/*    registers.h.ah = 0x8;
    registers.h.dl = 0x80;
    int86(0x13, &registers, &registers);
    if (registers.x.cflag) {
	printf("Hard disk bilgileri okunamadi!\n\a");
	exit(1);
    } */
    sprintf(temp, "\n Model Number______________________: %s", getascii(dd, 27, 46));
    puts(temp);
    sprintf(temp, " Serial Number_____________________: %s", getascii(dd, 10, 19));
    puts(temp);
    sprintf(temp, " Controller Revision Number________: %s", getascii(dd, 23, 26));
    puts(temp);
    sprintf(temp, " Able to do Double Word Transfer___: %6s", (dd[48] == 0 ? "No" : "Yes"));
    puts(temp);
    sprintf(temp, " Controller type___________________:   %04X", dd[20]);
    puts(temp);
    sprintf(temp, " Controller buffer size (bytes)____: %6u", dd[21] * 512);
    puts(temp);
    sprintf(temp, " Number of ECC bytes transferred___: %6u", dd[22]);
    puts(temp);
    sprintf(temp, " Number of sectors per interrupt___: %6u", dd[47]);
    puts(temp);
    sprintf(temp, " Number of Cylinders (Fixed)_______: %6u", dd[1]);
    puts(temp);
    sprintf(temp, " Number of Heads___________________: %6u", dd[3]);
    puts(temp);
    sprintf(temp, " Number of Sectors per Track_______: %6u", dd[6]);
    puts(temp);
}
