#include "dflat.h"
#include "ara.h"
#include "arafont.h"

#define CHARSLINE 80
#define LINESPAGE 66

extern void tunnel21(void); /* model large */
extern void tunnel13(void); /* model large */
void interrupt(*old21) (__CPPARGS);
void interrupt(*new21) (__CPPARGS);
void interrupt(*old13) (__CPPARGS);
void interrupt(*new13) (__CPPARGS);
int tunnel = 0;
unsigned char E;
char self_name[20];
int WindowsActive, handle, MVer, SVer;

char DFlatApplication[] = "ARA";
static int wndpos;
char **Argv;
WINDOW aramain, araniyor, rapor;
FILE *tempfp;
char p_ismi[500];
unsigned char ozet = 0;
unsigned char sil = 0;
unsigned char addcrc = 0;
unsigned char delcrc = 0;
unsigned char usecrc = 0;
unsigned char clncrc = 1;
unsigned char tmpcrc = 0;
unsigned char tm2crc = 0;
unsigned char tm3crc = 0;
unsigned char nolook = 0;
unsigned char askcrc = FALSE;
unsigned char askall = TRUE;
int crcfile;

void b_ara(void)
{
    char m1[] = {
	"Programn doru alabilmesi iin en az VGA grafik kartl,Dos3.0 yada\n"
	"yukars iletim sistemi olan bir 80386 bilgisayar gerekli.\n\n"
	"Her ne kadar programn tasarm ve denenmesi srasnda mmkn olan her\n"
	"art dnldyse de programn kullanmndan doacak her hangi bir za-\n"
	"rar karsnda programn yazar hibir ekilde sorumlu tutulamaz.\n\n"
	"Program kullanrsanz yukardaki art otomatik olarak kabul etmi\n"
	"saylrsnz."};
/*	"Bu program SHAREWARE' dir ve 10 gnlk deneme sresi sonunda kullanma-\n"
	"ya devam etmek isterseniz bana bir miktar para yollamalsnz. Detay-\n"
	"lar iin ltfen MANUAL.EXE dosyasnn iine bakn. Eer bu dosya eli-\n"
    "nizde yoksa benimle irtibata gein."}; */

    MessageBox(
	       "ARA NEDR, NE DELDR ?",
	       m1);
}

void b_yazar(void)
{
    char m1[] = {
	"Hala kendini gelitirmeye alan bir Elektronik Mhendisiyim...\n"
	"Bilgisayarla tanmam ilkokul 4. snfta, bir arkadan evinde\n"
	"grdm Spectrum ZX ile oldu. Ekranda grdm grafikler beni\n"
	"bylemiti. ok gemeden kendime bir Commodore 64 aldrmay\n"
	"baardm ;-) Bylece serven balad...\n"
	"imdi bu noktadaym. Size kendi yazdm bir program iinden\n"
	"sesleniyorum. Ama iin en gzel yan beni ilk bata etkileyen\n"
	"bynn etkisini kaybetmeden devam ediyor olmas. Hala hergn\n"
	"yeni eyler reniyorum ve yeni servenler yayorum...\n"
	"u ana kadar hep DOS iletim sistemi iin programlar yazdm.\n"
	"imdi oktan len ama hayalet olarak yaamn srdren bu\n"
	"iletim sistemini bir keye brakp btn gcmle 32-bit windows\n"
	"programlama zerinde urayorum. Bu sistemde program yazmak\n"
	"bana ayr bir tad veriyor. Sanrm bu tadlar srd srece de\n"
    "program yazmaya devam edeceim :-)"};

    MessageBox(
	       "BEN KMM ?",
	       m1);
}
/*
void b_odeme(void)
{
    char m1[] = {
	"Nedense herkes beni arayp program nasl alabileceklerini soruyor.\n"
	"Ltfen beni aramadan nce paketin iindeki MANUAL.EXE dosyasn\n"
    "altrp okuyun!"};

    MessageBox(
	       "DEMEK PARA YOLLAYACAKSINIZ :-)",
	       m1);
} */


void b_cont(void)
{
    char m1[] = {
	"Alfabetik sra ile;\n"
	"Internet eriimimi salayan:\n"
	"  Murat ILIMAN,\n"
	"Tunnel sistemine yardmc olan:\n"
	"  JauMing TSENG,\n"
	"Programa ekleyebilmem iin bana virs yollayan:\n"
	"  Blent BNC, Ersin KEC, Furkan DUMAN, smail CAN,\n"
	"  Mustafa TUFAN, mr YILDIZ, Sedat KAPANOLU,\n"
	"Beta versiyonlarn test eden ve hatalarm bulan:\n"
	"  Erdem TEKSEN, Erman MFTOLU, Furkan DUMAN, Tarhan TEMUN,\n"
	"Programn datmndaki yardmlarndan tr:\n"
	"  Blent BNC, Dimitri KARASAVA, Hakan KSEOLU, Muhammet TAILAR,\n"
	"  Murat ILIMAN, Nesim RAZON, Onur KONURALP, nder KKTRK,\n"
	"ve shareware'in anlamn kavrayp destekleyen herkese teekkr\n"
    "bir bor bilirim."};

    MessageBox(
	       "TEEKKRLER",
	       m1);
}

void b_haber(void)
{
    char m1[] = {
	"DUR Kopya Koruma Programmn yazlm bitti. Bu program disketlere\n"
	"zel bir iaret koyarak kopyalanmalarn engelliyor. Sizin bildiiniz\n"
	"ve sizin bilmeyip de benim bildiim btn kopyalama programlarnda\n"
	"baar salyor :) Zaten DUR'un yazl amacda kendi yazdm prog-\n"
	"ramlar korumak iindi. Bu yzden en iyi ekilde yazld. Eer yaz-\n"
	"dnz programlar iin maliyeti az ve etkili bir kopya korumas is-\n"
    "tiyorsanz DUR bence en iyi seenek."};

    MessageBox(
	       "HABERLER",
	       m1);
}

void ozet_dosyasini_ac(void)
{
    char *ptr;
    _fmemset(p_ismi, '\0', 500);
    ptr = getenv("TEMP");
    if (ptr == NULL)
	_fstrcpy(p_ismi, "c:\\ara.tmp");
    else {
	_fstrcpy(p_ismi, ptr);
	_fstrcat(p_ismi, "\\ara.tmp");
    }
    tempfp = fopen(p_ismi, "wt");
}



void uyari(void)
{
    char u[500];
    char uyari_mesaji[][50] = {
	"virs bulundu",	// 0
	"ile sktrlm dosya",	// 1
	"ile ifrelenmi dosya",// 2
	"ile imza braklm dosya",	// 3
	"ile alanm dosya",	// 4
	"ile maximum sktrlm dosya",	// 5
	"bilgisi yanl. Virs iareti olabilir",	// 6
	"mutant olabilir",	// 7
	"ile deitirilmi dosya",	// 8
	"trojan bulundu",	// 9
	"stub bilgisi bulundu",	// 10
	"yeni bir virs olabilir ???",	// 11
	"exe/com dosyas",	// 12
	"isimli aka program bulundu",	// 13
	"dosya deimi ???",	// 14
	"polimorfik virs bulundu", //15
    };
    sprintf(u, "%013s ---> %s %s\0", ffblk.ff_name, index[i].isim, uyari_mesaji[index[i].mesaj]);
    if (lasty > 13) {
	SendMessage(rapor, PAINT, 0, 0);
	lasty = 0;
    }
    PutWindowLine(rapor, u, 1, lasty++);
    sprintf(u, "%s\\%s ---> %s %s\n", dizin, ffblk.ff_name, index[i].isim, uyari_mesaji[index[i].mesaj]);
    if (ozet)
	fprintf(tempfp, u);
}


void boot_uyari(void)
{
    char u[200];
    sprintf(u, "BOOT/MBR ---> %s virs bulundu\0", sektor[i].isim);
    PutWindowLine(rapor, u, 1, lasty++);
    if (ozet)
	fprintf(tempfp, "%s\n", u);
}


void boot_tara(void)
{
    int c;
    PutWindowLine(araniyor, "Boot Sektr\0", 1, 0);
    surucu = getdisk();
    absread(surucu, 1, 0, bufr);
    c = bufr[1] + 2;
    for (i = 0; i < BOOT; i++) {
	for (l = 0; l < 10; l++)
	    sektor[i].imza[l] ^= kod;
	for (j = c; j < 512; j++) {
	    for (k = 0; k < 10; k++)
		if (sektor[i].imza[k] != bufr[j + k] && sektor[i].imza[k] != 63)
		    break;
	    if (k == 10) {
		boot_uyari();
		++vcount;
	    }
	}
	for (l = 0; l < 10; l++)
	    sektor[i].imza[l] ^= kod;
    }
    if (surucu > 1) {
	PutWindowLine(araniyor, "Master Boot\0", 1, 0);
	biosdisk(0x0a, 0x80, 0, 0, 1, 1, bufr);
	for (i = 0; i < BOOT; i++) {
	    for (l = 0; l < 10; l++)
		sektor[i].imza[l] ^= kod;
	    for (j = 0; j < 512; j++) {
		for (k = 0; k < 10; k++)
		    if (sektor[i].imza[k] != bufr[j + k] && sektor[i].imza[k] != 63)
			break;
		if (k == 10) {
		    boot_uyari();
		    ++vcount;
		}
	    }
	    for (l = 0; l < 10; l++)
		sektor[i].imza[l] ^= kod;
	}
    }
}


static int RaporProc(WINDOW wnd, MESSAGE msg, PARAM p1, PARAM p2)
{
    int rtn;
    switch (msg) {
    case SETFOCUS:
	if ((int) p1) {
	    wnd->InsertMode = GetCommandToggle(&MainMenu, ID_INSERT);
	    wnd->WordWrapMode = GetCommandToggle(&MainMenu, ID_WRAP);
	}
	rtn = DefaultWndProc(wnd, msg, p1, p2);
	if ((int) p1 == FALSE)
	    SendMessage(GetParent(wnd), ADDSTATUS, 0, 0);
	return rtn;
    case KEYBOARD_CURSOR:
	rtn = DefaultWndProc(wnd, msg, p1, p2);
	return rtn;
    case COMMAND:
	switch ((int) p1) {
	case ID_HELP:
	    DisplayHelp(wnd, "ARADOC");
	    return TRUE;
	default:
	    break;
	}
	break;
    case CLOSE_WINDOW:
	wndpos = 0;
	if (wnd->extension != NULL) {
	    free(wnd->extension);
	    wnd->extension = NULL;
	}
	break;
    default:
	break;
    }
    return DefaultWndProc(wnd, msg, p1, p2);
}

static int AraniyorProc(WINDOW wnd, MESSAGE msg, PARAM p1, PARAM p2)
{
    int rtn;
    switch (msg) {
    case SETFOCUS:
	if ((int) p1) {
	    wnd->InsertMode = GetCommandToggle(&MainMenu, ID_INSERT);
	    wnd->WordWrapMode = GetCommandToggle(&MainMenu, ID_WRAP);
	}
	rtn = DefaultWndProc(wnd, msg, p1, p2);
	if ((int) p1 == FALSE)
	    SendMessage(GetParent(wnd), ADDSTATUS, 0, 0);
	return rtn;
    case CLOSE_WINDOW:
	wndpos = 0;
	if (wnd->extension != NULL) {
	    free(wnd->extension);
	    wnd->extension = NULL;
	}
	break;
    default:
	break;
    }
    return DefaultWndProc(wnd, msg, p1, p2);
}

/*
void xlc_spaw(char *txt, char *cml)
{
  union REGS r;
  struct SREGS s;
  unsigned char xlc_name[80];
  sprintf(xlc_name, " %s", cml);
  r.x.ax = 0x4b00;
  s.ds = FP_SEG(txt);
  r.x.dx = FP_OFF(txt);
  poke(s.es, r.x.bx+2, FP_OFF(xlc_name));
  poke(s.es, r.x.bx+4, FP_SEG(xlc_name));
  intdosx(&r, &r, &s);
}


void mtara(void)
{
    FILE *f;
    struct ftime ft;
    unsigned char c;
    char u[100];
    char v[100];
    char satir[100];
    getcurdir(0, dizin);
    SendMessage(araniyor, PAINT, 0, 0);
    sprintf(u, "%c:\\%s\\%s\0", surucu + 65, dizin, ffblk.ff_name);
    PutWindowLine(araniyor, u, 1, 0);
    xlc_spaw("macro.drv", ffblk.ff_name);
    //spawnlp(P_WAIT, "macro.drv", "macro.drv", ffblk.ff_name, NULL);
    _fmemset(u, 0, 100);
    _fmemcpy(u, ffblk.ff_name, _fstrlen(ffblk.ff_name) - 4);
    _fstrcat(u, ".MAC");
    if ((f = fopen(u, "rt")) == NULL) {
	remove(u);
	return;
    }
    do {
	fgets(satir, 80, f);
	for (i = 0; i < MAKRO; i++) {
	     if (!_fmemcmp(mak[i].imza, satir, 20)) {
		 buldu = 1;
		 sprintf(v, "%013s ---> %s makro virs bulundu.\0", ffblk.ff_name, mak[i].isim);
		 if (lasty > 13) {
		     SendMessage(rapor, PAINT, 0, 0);
		     lasty = 0;
		 }
		 PutWindowLine(rapor, v, 1, lasty++);
		 sprintf(v, "%s\\%s ---> %s makro virs bulundu.\n", dizin, ffblk.ff_name, mak[i].isim);
		 if (ozet)
		     fprintf(tempfp, v);
		 break;
	     }
	}
    } while(!feof(f) && !buldu);
    if (buldu) {
	vcount++;
    }
    buldu = 0;
    fclose(f);
    remove(u);
}

*/

void btara(void)
{
    struct ftime ft;
    unsigned char c;
    char u[100];
    char m = 0, n = 0;
    getcurdir(0, dizin);
    SendMessage(araniyor, PAINT, 0, 0);
    sprintf(u, "%c:\\%s\\%s\0", surucu + 65, dizin, ffblk.ff_name);
    PutWindowLine(araniyor, u, 1, 0);
    if ((in = open(ffblk.ff_name, O_RDONLY | O_BINARY | O_DENYNONE | SH_DENYNONE)) == -1) {
	return;
    }
    read(in, bufr, 10);
    for (i = 0; i < MAX; i++) {
	if (index[i].ara_seek_size != 0) {
	    lseek(in, -(long) index[i].ara_seek_size, 2);
	    read(in, bufr, 10);
	}
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
	for (k = 0; k < 10; k++) {
	    if (index[i].imza[k] != bufr[k] && index[i].imza[l] != 63)
		break;
	}
	if (k == 10) {
	    buldu = 1;
	    close(in);
	    if (!m) {
		uyari();
		m = 1;
	    }
	}
	if (buldu && (index[i].mesaj == 0 || index[i].mesaj == 7 || index[i].mesaj == 9) && !n) {
	    vcount++;
	    n = 1;
	} else {
	    if (buldu && index[i].mesaj == 11 && !n) {
		pcount++;
		n = 1;
	    }
	}
	buldu = 0;
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
    }
    m = n = 0;
    close(in);
}

void restorecrc(void)
{
    int tf;
    struct stat stbuf;
    char u[500];

    stat(crc.isim, &stbuf);
    if ((stbuf.st_mode & S_IWRITE) != 0x80)
	chmod(crc.isim, S_IREAD | S_IWRITE);
    if ((tf = open(crc.isim, O_RDWR | O_BINARY | SH_DENYRW)) == -1) {
	ErrorMessage("Dosya alamyor! lem iptal edildi.");
    } else {
	switch (crc.ftype) {
	case 1:
	    write(tf, crc.j, 3);
	    chsize(tf, crc.l);
	    break;
	case 2:
	    lseek(tf, 2, SEEK_SET);
	    write(tf, crc.fs, 4);
	    lseek(tf, 14, SEEK_SET);
	    write(tf, crc.s, 4);
	    lseek(tf, 20, SEEK_SET);
	    write(tf, crc.i, 4);
	    chsize(tf, crc.l);
	    break;
	}
	close(tf);
	tcount++;
	sprintf(u, "%013s ---> dosya CRC bilgileri ile eski haline getirildi", crc.isim);
	if (lasty > 13) {
	    SendMessage(rapor, PAINT, 0, 0);
	    lasty = 0;
	}
	PutWindowLine(rapor, u, 1, lasty++);
	sprintf(u, "%s\\%s ---> dosya CRC bilgileri ile eski haline getirildi\n", dizin, crc.isim);
	if (ozet)
	    fprintf(tempfp, u);
    }
}

void polytara(void)
{
    switch(index[i].ara_seek_size) {
	case 1:
	     if (f_type == 1) {
		 cur_loc = tell(in);
		 read(in, bufr, 3);
		 if (bufr[0] == 0xBD && (bufr[1] + bufr[2] * 0x100) == cur_loc) {
		     uyari();
		     vcount++;
		 }
	     lseek(in, jmp, 0);
	     }
	     break;
	default:
	     return;
    }
}

void tara(void)
{
    struct ftime ft;
    unsigned char c;
    int cevap;
    char u[100];
    char m = 0, n = 0;
    char match = 0;
    unsigned char crckontrol[4];
    char m1[] = {
	"Yukarda ismi geen dosya deimi. CRC dosyasndaki eski bilgileri\n"
	"geri yklemek ister misiniz? (Eer virsten pheleniyorsanz bu ilem\n"
	"sonunda virsnz dosyadan temizlenecektir. Yazlan bilgilerle dosya\n"
	"en son CRC bilgilerinin kaydedildii zamanki gibi olacaktr. O yzden\n"
	"ltfen ne yaptnzdan eminseniz bu ilemi yapn. Daha fazla detay\n"
	"iin programn iindeki yardmlara bakabilirsiniz)\n\n"
    "                     Eski bilgiler yklensin mi?"};
    char m2[] = {
	"imdi isterseniz yalnz yukaridaki dosyay eski haline getirebilir ya\n"
	"da bundan sonraki benzer her dosyay otomatik olarak temizletebilirsi-\n"
	"niz. Size tavsiye edilen ilk nce yalnz tek bir dosyay eski haline\n"
	"getirip dikkatlice test etmeniz ve eer bir sorun grmezseniz dier\n"
	"dosyalarda temizletmenizdir. Eer EVET seerseniz bu yaplacaktr.\n"
	"HAYIR seerek btn dosyalar eski hallerine getirebilirsiniz.\n\n"
    "         Yalnz yukaridaki dosyay m deitirmek istiyorsunuz?"};

    getcurdir(0, dizin);
    SendMessage(araniyor, PAINT, 0, 0);
    sprintf(u, "%c:\\%s\\%s\0", surucu + 65, dizin, ffblk.ff_name);
    PutWindowLine(araniyor, u, 1, 0);
    if ((in = open(ffblk.ff_name, O_RDONLY | O_BINARY | O_DENYNONE | SH_DENYNONE)) == -1) {
	return;
    }
    _fstrcpy(crc.isim, ffblk.ff_name);
    read(in, &exe_sign, 2);
    if (exe_sign[0] != 0x4d && exe_sign[1] != 0x5a)
	f_type = 1;
    else
	f_type = 2;
    f_size = filelength(in);
    crc.l = f_size;
    if (f_type == 1) {
	lseek(in, 0, 0);
	read(in, crckontrol, 4);
	_fmemcpy(ejmp, crckontrol, 3);
	crc.ftype = 1;
	_fmemcpy(crc.j, ejmp, 3);
	_fmemcpy(crc.i, crckontrol, 4);
	if (ejmp[0] == 0xeb)
	    jmp = (unsigned) ejmp[1] + 2;
	else if (ejmp[0] == 0xe9)
	    jmp = (unsigned) ejmp[1] + 256 * (unsigned) ejmp[2] + 3;
	else
	    jmp = 0;
	lseek(in, jmp, 0);
    } else {
	lseek(in, 2, 0);
	read(in, crc.fs, 4);
	lseek(in, 8, 0);
	read(in, &header, sizeof(header));
	lseek(in, 14, 0);
	read(in, crc.s, 4);
	lseek(in, 20, 0);
	read(in, &ip1, sizeof(ip1));
	read(in, &ip2, sizeof(ip2));
	crc.ftype = 2;
	_fmemcpy(crc.i, &ip1, 2);
	_fmemcpy(crc.i + 2, &ip2, 2);
	_fmemcpy(crckontrol, crc.i, 4);
	ip = (unsigned long) ip2 *16 + header * 16 + ip1;
	if (ip > f_size)
	    ip = header * 16;
	lseek(in, ip, 0);
    }
    if (addcrc) {
	_write(crcfile, &crc, sizeof(crc));
    }
    if (usecrc) {
	if ((crcfile = open("ara.crc", O_RDONLY | O_BINARY | O_DENYNONE | SH_DENYNONE)) == -1) {
	    nolook = 1;
	} else {
	    while (!eof(crcfile) && !match) {
		read(crcfile, &crc, sizeof(crc));
		if (!_fmemicmp(crc.isim, ffblk.ff_name, _fstrlen(crc.isim)))
		    match = 1;
	    }
	    if (!match)
		nolook = 1;
	    close(crcfile);
	    match = 0;
	}
    }
    for (i = 0; i < MAX; i++) {
	 if ((unsigned)index[i].mesaj == 15) {
	     polytara();
	 }
    }
    read(in, bufr, 6);
    while (bufr[0] == 0xe8 || bufr[0] == 0xe9 || bufr[0] == 0xeb || bufr[0] == 0x90) {
	switch (bufr[0]) {
	case 0xe8:
	    jmpex = (long) bufr[1] + 256 * (long) bufr[2] + 3;
	    if (jmpex > f_size)
		jmpex = jmpex - (65536 / jmpex * 65536);
	    if (f_type == 1) {
		jmp += jmpex;
		lseek(in, jmp, 0);
	    } else {
		ip += jmpex;
		while (ip > f_size)
		    ip -= 65536;
		lseek(in, ip, 0);
	    }
	    read(in, bufr, 6);
	    break;
	case 0xe9:
	    jmpex = (long) bufr[1] + 256 * (long) bufr[2] + 3;
	    if (f_type == 1) {
		jmp += jmpex;
		lseek(in, jmp, 0);
	    } else {
		ip += jmpex;
		while (ip > f_size)
		    ip -= 65536;
		lseek(in, ip, 0);
	    }
	    read(in, bufr, 6);
	    break;
	case 0xeb:
	    jmpex = (long) bufr[1] + 2;
	    if (f_type == 1) {
		jmp += jmpex;
		lseek(in, jmp, 0);
	    } else {
		ip += jmpex;
		while (ip > f_size)
		    ip -= 65536;
		lseek(in, ip, 0);
	    }
	    read(in, bufr, 6);
	    break;
	case 0x90:
	    lseek(in, -5, 1);
	    read(in, bufr, 6);
	    ip++;
	    jmp++;
	    if (ip > f_size || jmp > f_size)
		bufr[0] = 0xFF;
	    break;
	}
    }
    cur_loc = tell(in);
    read(in, bufr + 6, 47);

    getftime(in, &ft);
    if (ft.ft_hour > 59 || ft.ft_min > 59 || (ft.ft_tsec * 2) > 59 || ft.ft_month > 12 || ft.ft_day > 31 || ft.ft_year == 0) {
	i = 0;
	buldu = 1;
	uyari();
    }
    for (i = 0; i < MAX; i++) {
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
	l = 0;
	for (k = 0; l < 10; k++) {
	    if (bufr[index[i].ara_seek_size + k] != 0x90) {
		if (index[i].imza[l] != bufr[index[i].ara_seek_size + k] && index[i].imza[l] != 63)
		    break;
		l++;
	    }
	}
	if (l == 10) {
	    buldu = 1;
	    close(in);
	    if (!m) {
		if (index[i].mesaj == 11) {
		    if (f_size - cur_loc < 1500) {
			pcount++;
			uyari();
		    }
		    m = 1;
		} else {
		    uyari();
		    m = 1;
		}
	    }
	}
	if (buldu && (index[i].mesaj == 0 || index[i].mesaj == 7 || index[i].mesaj == 9) && !n) {
	    vcount++;
	    if (sil)
		remove(ffblk.ff_name);
	    n = 1;
	} else {
	    if (buldu && index[i].mesaj == 11 && !n && f_size - cur_loc < 1500) {
		n = 1;
	    }
	}
	buldu = 0;
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
    }

    m = n = 0;
    close(in);
    if (!nolook) {
	if (f_size != crc.l || _fmemcmp(crckontrol, crc.j, 3) || _fmemcmp(crckontrol, crc.i, 4)) {
	    switch (crc.ftype) {
	    case 1:
		if (_fmemcmp(crc.j, ejmp, 3)) {
		    index[i].mesaj = 14;
		    _fstrcpy(index[i].isim, "???\0");
		    if (!clncrc)
			uyari();
		    else {
			if (askall == TRUE) {
			    askcrc = YesNoBox(m1);
			    if (askcrc != TRUE) {
				clncrc = 0;
				uyari();
			    } else {
				askall = YesNoBox(m2);
				if (askall == FALSE) {
				    restorecrc();
				} else {
				    clncrc = 0;
				    restorecrc();
				}
			    }
			} else {
			    restorecrc();
			}
		    }
		    pcount++;
		}
		break;
	    case 2:
		if (_fmemcmp(crc.i, &ip1, 2) || _fmemcmp(crc.i + 2, &ip2, 2)) {
		    index[i].mesaj = 14;
		    _fstrcpy(index[i].isim, "???\0");
		    if (!clncrc)
			uyari();
		    else {
			if (askall == TRUE) {
			    askcrc = YesNoBox(m1);
			    if (askcrc != TRUE) {
				clncrc = 0;
				uyari();
			    } else {
				askall = YesNoBox(m2);
				if (askall == FALSE) {
				    restorecrc();
				} else {
				    clncrc = 0;
				    restorecrc();
				}
			    }
			} else {
			    restorecrc();
			}
		    }
		    pcount++;
		}
		break;
	    }
	}
    }
    nolook = 0;
}

int readkey(void)
{
    int key = 0;
    if (bioskey(1) != 0) {
	key = bioskey(0);
	key = key >> 8;
    }
    return key;
}

void explore(void)
{
    int n, done;
    done = findfirst("*.*", &ffblk, FA_DIREC | FA_HIDDEN | FA_SYSTEM | FA_RDONLY | FA_ARCH);
    n = ndir;
    while (!done && !E) {
	if ((ffblk.ff_attrib & 16) == FA_DIREC) {
	    if (_fstrcmp(ffblk.ff_name, ".") && _fstrcmp(ffblk.ff_name, "..")) {
		_fstrcpy(names[ndir++], ffblk.ff_name);
	    }
	} else {
	    ++fcount;
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".COM", 4))
		tara();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".EXE", 4))
		tara();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".BAT", 4))
		btara();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".BIN", 4))
		tara();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".OV", 3))
		tara();
	}
	if (readkey() == 1) {
	    if (YesNoBox("ARAmay iptal etmek istiyor musunuz?")) {
		E = 1;
		return;
	    }
	}
	done = findnext(&ffblk);
    }
    while (ndir > n) {
	ndir -= 1;
	chdir(names[ndir]);
	getcurdir(0, dizin + 3);
	if (addcrc) {
	    delcrc = 0;
	    usecrc = 0;
	    close(crcfile);
	    if ((crcfile = _creat("ara.crc", FA_HIDDEN)) == -1) {
		ErrorMessage(sys_errlist[errno]);
		addcrc ^= 1;
	    }
	}
	if (delcrc) {
	    addcrc = 0;
	    usecrc = 0;
	    remove("ara.crc");
	}
	explore();
	chdir("..");
	if (addcrc)
	    close(crcfile);
	++dcount;
	if (dcount > 2000)
	    return;
    }
}

static int LoadFile(WINDOW wnd)
{
    char *Buf = NULL;
    int recptr = 0;
    FILE *fp;
    char m1[] = {
	"Rapor dosyasn gstermek iin hafza yetersiz!\n"
	"sterseniz imdi programdan kp TEMP dizini ya da\n"
	"C: nin ROOT'unda olan ARA.TMP dosyasna kendi text\n"
    "gstericiniz ile bakabilirsiniz."};

    if ((fp = fopen(p_ismi, "rt")) != NULL) {
	if (filelength(fileno(fp)) < 30000) {
	    while (!feof(fp)) {
		handshake();
		Buf = DFrealloc(Buf, recptr + 150);
		_fmemset(Buf + recptr, 0, 150);
		fgets(Buf + recptr, 150, fp);
		recptr += _fstrlen(Buf + recptr);
	    }
	    fclose(fp);
	    if (Buf != NULL) {
		SendMessage(wnd, SETTEXT, (PARAM) Buf, 0);
		free(Buf);
		return (0);
	    }
	} else {
	    fclose(fp);
	    SendMessage(rapor, CLOSE_WINDOW, 0, 0);
	    ErrorMessage(m1);
	    return (1);
	}
    }
    return (0);
}


void basla(void)
{
    struct REGPACK reg;
    char satir[280];
    char ch, buffer[2048];
    int result, i, total, r;

    if (isVisible(rapor))
	SendMessage(rapor, CLOSE_WINDOW, 0, 0);
    if (ozet)
	ozet_dosyasini_ac();
    lasty = 0;
    araniyor = CreateWindow(TEXTBOX,
			    NULL,
			    4, 3, 3, 72,
			    NULL,
			    aramain,
			    AraniyorProc,
			    SHADOW |
			    CONTROLBOX |
			    HASBORDER
	);
    SendMessage(araniyor, SETFOCUS, TRUE, 0);
    rapor = CreateWindow(TEXTBOX,
			 NULL,
			 2, 7, 16, 76,
			 NULL,
			 aramain,
			 RaporProc,
			 SHADOW |
			 CONTROLBOX |
			 HASBORDER
	);
    SendMessage(rapor, SETFOCUS, TRUE, 0);
    tcount = vcount = fcount = dcount = ndir = sormadan = buldu = pcount = 0;
    E = 0;
    boot_tara();
    explore();
    usecrc = tmpcrc;
    addcrc = tm2crc;
    delcrc = tm3crc;
    askcrc = FALSE;
    askall = TRUE;
    sprintf(satir, " ARAnan dizin says:      %04d\n\
 ARAnan dosya says:      %04d\n\
 Bulunan virs says:     %04d\n\
 pheli dosya says:     %04d\n\
 Temizlenen dosya says:  %04d\n", dcount, fcount, vcount, pcount, tcount);
    if (!vcount && !pcount) {
	MessageBox(
		   NULL,
		   satir);
    } else {
	MessageBox2(
		    NULL,
		    satir);
    }
    SendMessage(rapor, CLOSE_WINDOW, 0, 0);
    SendMessage(araniyor, CLOSE_WINDOW, 0, 0);
    if (ozet) {
	fprintf(tempfp, "--------------------------------------------------------\n");
	fprintf(tempfp, " ARAnan dizin says:      %04d\n", dcount);
	fprintf(tempfp, " ARAnan dosya says:      %04d\n", fcount);
	fprintf(tempfp, " Bulunan virs says:     %04d\n", vcount);
	fprintf(tempfp, " pheli dosya says:     %04d\n", pcount);
	fprintf(tempfp, " Temizlenen dosya says:  %04d\n", tcount);
	fclose(tempfp);
	rapor = CreateWindow(TEXTBOX,
			     "Rapor",
			     2, 3, 20, 76,
			     NULL,
			     aramain,
			     RaporProc,
			     SHADOW |
			     MINMAXBOX |
			     CONTROLBOX |
			     VSCROLLBAR |
			     HASBORDER |
			     MULTILINE
	    );
	r = LoadFile(rapor);
	if (!r)
	    SendMessage(rapor, SETFOCUS, TRUE, 0);
    }
}

int handler(int errval, int ax, int bp, int si)
{
    ax = ax;
    bp = bp;
    si = si;
    ErrorMessage("Hardware ilikili hata tespit edildi!");
    hardretn(errval);
    return (errval);
}

int windows(int *MVersion, int *SVersion)
{
    union REGS regs;
    struct SREGS sregs;

    *MVersion = 0;
    *SVersion = 0;

    regs.x.ax = 0x1600;
    segread(&sregs);
    int86x(MULTIPLEX, &regs, &regs, &sregs);

    switch (regs.h.al) {
    case 0x01:
    case 0xFF:
	*MVersion = 2;
	*SVersion = 0;
	return W_386_X;

    case 0x00:
    case 0x80:
	regs.x.ax = 0x4680;
	int86x(MULTIPLEX, &regs, &regs, &sregs);
	if (regs.h.al == 0x80)
	    return NO_WIN;
	else {
	    regs.x.ax = 0x1605;
	    regs.x.bx = regs.x.si = regs.x.cx =
		sregs.es = sregs.ds = 0x0000;
	    regs.x.dx = 0x0001;
	    int86x(MULTIPLEX, &regs, &regs, &sregs);
	    if (regs.x.cx == 0x0000) {
		regs.x.ax = 0x1606;
		int86x(MULTIPLEX, &regs, &regs, &sregs);
		return W_REAL;
	    } else
		return W_STANDARD;
	}
    default:
	*MVersion = regs.h.al;
	*SVersion = regs.h.ah;
	return W_ENHANCED;
    }
}


static void SelectHedef(WINDOW wnd)
{
    char FileName[15];
    wnd = wnd;
    OpenFileDialogBox("*.*", FileName);
}

void showtunnel(void)
{
    char m1[] =
    "ARA hafzada aktif olabilecek virsleri\n"
    "gemek iin \"tunneling\" kullanyor!";
    char m2[] =
    "ARA \"tunneling\" kullanmyor.\n"
    "Sebep: Adres bulunamad ya da gerek grlmedi!";
    char m3[100];

    sprintf(m3, "ARA \"tunneling\" kullanmyor.\nSebep: Program Windows v%d.%d altnda altrlyor!", MVer, SVer);

    if (tunnel == 4)
	MessageBox("Tunneling Durumu", m1);
    else {
	if (WindowsActive == NO_WIN)
	    MessageBox2("Tunneling Durumu", m2);
	else
	    MessageBox2("Tunneling Durumu", m3);
    }
}


static int ARAProc(WINDOW wnd, MESSAGE msg, PARAM p1, PARAM p2)
{
    int rtn;
    switch (msg) {
    case COMMAND:
	switch ((int) p1) {
	case ID_OPEN:
	    eski_surucu = getdisk();
	    sprintf(eski_dizin, "%c:\\", eski_surucu + 'A');
	    getcurdir(0, eski_dizin + 3);
	    chdir("\\");
	    SelectHedef(wnd);
	    yeni_surucu = getdisk();
	    sprintf(yeni_dizin, "%c:\\", yeni_surucu + 'A');
	    getcurdir(0, yeni_dizin + 3);
	    setdisk(eski_surucu);
	    chdir(eski_dizin);
	    return TRUE;
	case ID_START:
	    if (yeni_surucu != 99) {
		setdisk(yeni_surucu);
		chdir(yeni_dizin);
	    }
	    basla();
	    setdisk(eski_surucu);
	    chdir(eski_dizin);
	    return TRUE;
	case ID_TUNNEL:
	    showtunnel();
	    return TRUE;
	case ID_EXIT:
	    if (!YesNoBox("kmak istiyor musunuz?"))
		return FALSE;
	    break;
	case ID_OZET:
	    ozet ^= 1;
	    return TRUE;
	case ID_SIL:
	    sil ^= 1;
	    return TRUE;
	case ID_ADDCRC:
	    addcrc ^= 1;
	    tm2crc ^= 1;
	    return TRUE;
	case ID_REMOVECRC:
	    delcrc ^= 1;
	    tm3crc ^= 1;
	    return TRUE;
	case ID_CHKCRC:
	    usecrc ^= 1;
	    tmpcrc ^= 1;
	    return TRUE;
	case ID_CLNCRC:
	    clncrc ^= 1;
	    return TRUE;
	case ID_KAYDET:
	    setdisk(eski_surucu);
	    chdir(eski_dizin);
	    tempfp = fopen("ara_ayar.cfg", "wb");
	    fwrite(&ozet, 1, 1, tempfp);
	    fwrite(&sil, 1, 1, tempfp);
	    fwrite(&addcrc, 1, 1, tempfp);
	    fwrite(&delcrc, 1, 1, tempfp);
	    fwrite(&usecrc, 1, 1, tempfp);
	    fclose(tempfp);
	    chdir("\\");
	    return TRUE;
	case ID_INFARA:
	    b_ara();
	    return TRUE;
	case ID_INFYAZAR:
	    b_yazar();
	    return TRUE;
/*	case ID_INFPAY:
	    b_odeme();
	    return TRUE; */
	case ID_INFCONT:
	    b_cont();
	    return TRUE;
	case ID_HABER:
	    b_haber();
	    return TRUE;
	case ID_ABOUT:
	    MessageBox(
		       "ARA Anti-Virs Program",
		       " Ŀ\n"
		       "   ܳ\n"
		       "      ۳\n"
		       "    ۳\n"
		       "           ۳\n"
		       " \n"
		       "         FREEWARE         \n"
		       "          v4.31\n"
		       "        XX.XX.1997");
/*		       "        Registered to:\n"
		       "Ŀ\n"
		       "      168AATAY  NUHOLU    \n"
		       "    UNREGISTERED VERSION    \n"
		       "\n\n"); */
	    return TRUE;
	default:
	    break;
	}
	break;
    default:
	break;
    }
    return DefaultWndProc(wnd, msg, p1, p2);
}

int c_break(void)
{
    clreol();
    printf("ARAma iptal edildi.\n");
    clreol();
    setdisk(eski_surucu);
    chdir(eski_dizin);
    for (i = 0; i < sizeof(bufr); i++)
	bufr[i] ^= 0x03;
    if (tunnel == 4) {
	setvect(0x21, old21);
	setvect(0x13, old13);
    }
    return (0);
}


void uyarilite(void)
{
    char u[100];
    char uyari_mesaji[][50] = {
	"virs bulundu",	// 0
	"ile sktrlm dosya",	// 1
	"ile ifrelenmi dosya",// 2
	"ile imza braklm dosya",	// 3
	"ile alanm dosya",	// 4
	"ile maximum sktrlm dosya",	// 5
	"bilgisi yanl. Virs iareti olabilir",	// 6
	"mutant olabilir",	// 7
	"ile deitirilmi dosya",	// 8
	"trojan bulundu",	// 9
	"stub bilgisi bulundu",	// 10
	"yeni bir virs olabilir ???",	// 11
	"exe/com dosyas",	// 12
	"isimli aka program bulundu",	// 13
	"polimorfik virs bulundu", // 14
	"polimorfik virs bulundu", // 15
    };
    sprintf(u, "%013s ---> %s %s", ffblk.ff_name, index[i].isim, uyari_mesaji[index[i].mesaj]);
    printf("\n  %s\n", u);
}


void btaralite(void)
{
    struct ftime ft;
    unsigned char c;
    char u[100];
    char m = 0, n = 0;
    getcurdir(0, dizin);
    getcurdir(0, dizin);
    sprintf(u, "%c:\\%s\\%s\0", surucu, dizin, ffblk.ff_name);
    clreol();
    printf("%s\r", u);
    if ((in = open(ffblk.ff_name, O_RDONLY | O_BINARY | O_DENYNONE | SH_DENYNONE)) == -1) {
	return;
    }
    read(in, bufr, 10);
    for (i = 0; i < MAX; i++) {
	if (index[i].ara_seek_size != 0) {
	    lseek(in, -(long) index[i].ara_seek_size, 2);
	    read(in, bufr, 10);
	}
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
	for (k = 0; k < 10; k++) {
	    if (index[i].imza[k] != bufr[k] && index[i].imza[l] != 63)
		break;
	}
	if (k == 10) {
	    buldu = 1;
	    close(in);
	    if (!m) {
		uyarilite();
		m = 1;
	    }
	}
	if (buldu && (index[i].mesaj == 0 || index[i].mesaj == 7 || index[i].mesaj == 9) && !n) {
	    vcount++;
	    n = 1;
	} else {
	    if (buldu && index[i].mesaj == 11 && !n) {
		pcount++;
		n = 1;
	    }
	}
	buldu = 0;
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
    }
    m = n = 0;
    close(in);
}

void boot_taralite(void)
{
    int c;
    int surucu;
    printf("Boot Sektr\n");
    surucu = getdisk();
    absread(surucu, 1, 0, bufr);
    c = bufr[1] + 2;
    for (i = 0; i < BOOT; i++) {
	for (l = 0; l < 10; l++)
	    sektor[i].imza[l] ^= kod;
	for (j = c; j < 512; j++) {
	    for (k = 0; k < 10; k++)
		if (sektor[i].imza[k] != bufr[j + k] && sektor[i].imza[k] != 63)
		    break;
	    if (k == 10) {
		printf("   BOOT SEKTR ---> %s virs bulundu\n", sektor[i].isim);
		++vcount;
	    }
	}
	for (l = 0; l < 10; l++)
	    sektor[i].imza[l] ^= kod;
    }
    if (surucu > 1) {
	printf("Master Boot\n");
	biosdisk(0x0a, 0x80, 0, 0, 1, 1, bufr);
	for (i = 0; i < BOOT; i++) {
	    for (l = 0; l < 10; l++)
		sektor[i].imza[l] ^= kod;
	    for (j = 0; j < 512; j++) {
		for (k = 0; k < 10; k++)
		    if (sektor[i].imza[k] != bufr[j + k] && sektor[i].imza[k] != 63)
			break;
		if (k == 10) {
		    printf("MASTER BOOT ---> %s virs bulundu\0", sektor[i].isim);
		    ++vcount;
		}
	    }
	    for (l = 0; l < 10; l++)
		sektor[i].imza[l] ^= kod;
	}
    }
}

void polytaralite(void)
{
    switch(index[i].ara_seek_size) {
	case 1:
	     if (f_type == 1) {
		 cur_loc = tell(in);
		 read(in, bufr, 3);
		 if (bufr[0] == 0xBD && (bufr[1] + bufr[2] * 0x100) == cur_loc) {
		     uyarilite();
		     vcount++;
		 }
	     lseek(in, jmp, 0);
	     }
	     break;
	default:
	     return;
    }
}

void taralite(void)
{
    struct ftime ft;
    unsigned char c;
    char u[100];
    char m = 0, n = 0;
    getcurdir(0, dizin);
    sprintf(u, "%c:\\%s\\%s\0", surucu, dizin, ffblk.ff_name);
    clreol();
    printf("%s\r", u);
    if ((in = open(ffblk.ff_name, O_RDONLY | O_BINARY | O_DENYNONE | SH_DENYNONE)) == -1) {
	return;
    }
    read(in, &exe_sign, 2);
    if (exe_sign[0] != 0x4d && exe_sign[1] != 0x5a)
	f_type = 1;
    else
	f_type = 2;
    f_size = filelength(in);
    if (f_type == 1) {
	lseek(in, 0, 0);
	read(in, ejmp, 3);
	if (ejmp[0] == 0xeb)
	    jmp = (unsigned) ejmp[1] + 2;
	else if (ejmp[0] == 0xe9)
	    jmp = (unsigned) ejmp[1] + 256 * (unsigned) ejmp[2] + 3;
	else
	    jmp = 0;
	lseek(in, jmp, 0);
    }
    if (f_type == 2) {
	lseek(in, 8, 0);
	read(in, &header, sizeof(header));
	lseek(in, 20, 0);
	read(in, &ip1, sizeof(ip1));
	read(in, &ip2, sizeof(ip2));
	ip = (unsigned long) ip2 *16 + header * 16 + ip1;
	if (ip > f_size)
	    ip = header * 16;
	lseek(in, ip, 0);
    }
    for (i = 0; i < MAX; i++) {
	 if ((unsigned)index[i].mesaj == 15) {
	     polytaralite();
	 }
    }
    read(in, bufr, 6);
    while (bufr[0] == 0xe8 || bufr[0] == 0xe9 || bufr[0] == 0xeb || bufr[0] == 0x90) {
	switch (bufr[0]) {
	case 0xe8:
	    jmpex = (long) bufr[1] + 256 * (long) bufr[2] + 3;
	    if (jmpex > f_size)
		jmpex = jmpex - (65536 / jmpex * 65536);
	    if (f_type == 1) {
		jmp += jmpex;
		lseek(in, jmp, 0);
	    } else {
		ip += jmpex;
		while (ip > f_size)
		    ip -= 65536;
		lseek(in, ip, 0);
	    }
	    read(in, bufr, 6);
	    break;
	case 0xe9:
	    jmpex = (long) bufr[1] + 256 * (long) bufr[2] + 3;
	    if (f_type == 1) {
		jmp += jmpex;
		lseek(in, jmp, 0);
	    } else {
		ip += jmpex;
		while (ip > f_size)
		    ip -= 65536;
		lseek(in, ip, 0);
	    }
	    read(in, bufr, 6);
	    break;
	case 0xeb:
	    jmpex = (long) bufr[1] + 2;
	    if (f_type == 1) {
		jmp += jmpex;
		lseek(in, jmp, 0);
	    } else {
		ip += jmpex;
		while (ip > f_size)
		    ip -= 65536;
		lseek(in, ip, 0);
	    }
	    read(in, bufr, 6);
	    break;
	case 0x90:
	    lseek(in, -5, 1);
	    read(in, bufr, 6);
	    ip++;
	    jmp++;
	    if (ip > f_size || jmp > f_size)
		bufr[0] = 0xFF;
	    break;
	}
    }
    cur_loc = tell(in);
    read(in, bufr + 6, 47);

    getftime(in, &ft);
    if (ft.ft_hour > 59 || ft.ft_min > 59 || (ft.ft_tsec * 2) > 59 || ft.ft_month > 12 || ft.ft_day > 31 || ft.ft_year == 0) {
	i = 0;
	buldu = 1;
	uyarilite();
    }
    for (i = 0; i < MAX; i++) {
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
	l = 0;
	for (k = 0; l < 10; k++) {
	    if (bufr[index[i].ara_seek_size + k] != 0x90) {
		if (index[i].imza[l] != bufr[index[i].ara_seek_size + k] && index[i].imza[l] != 63)
		    break;
		l++;
	    }
	}
	if (l == 10) {
	    buldu = 1;
	    close(in);
	    if (!m) {
		if (index[i].mesaj == 11) {
		    if (f_size - cur_loc < 1500) {
			pcount++;
			uyarilite();
		    }
		    m = 1;
		} else {
		    uyarilite();
		    m = 1;
		}
	    }
	}
/*
	if (buldu && (index[i].mesaj != 6)) {
	    vcount++;
	    close(in);
	    remove(ffblk.ff_name);
	}
*/
	if (buldu && (index[i].mesaj == 0 || index[i].mesaj == 9) && !n) {
	    vcount++;
	    n = 1;
	} else {
	    if (buldu && index[i].mesaj == 11 && !n && f_size - cur_loc < 1500) {
		n = 1;
	    }
	}
	buldu = 0;
	for (l = 0; l < 10; l++)
	    index[i].imza[l] ^= kod;
    }
    m = n = 0;
    close(in);
}


void explorelite(void)
{
    int n, done;
    done = findfirst("*.*", &ffblk, FA_DIREC | FA_HIDDEN | FA_SYSTEM | FA_RDONLY | FA_ARCH);
    n = ndir;
    while (!done) {
	if ((ffblk.ff_attrib & 16) == FA_DIREC) {
	    if (_fstrcmp(ffblk.ff_name, ".") && _fstrcmp(ffblk.ff_name, "..")) {
		_fstrcpy(names[ndir++], ffblk.ff_name);
	    }
	} else {
	    ++fcount;
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".COM", 4))
		taralite();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".EXE", 4))
		taralite();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".BAT", 4))
		btaralite();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".BIN", 4))
		taralite();
	    if (!_fmemicmp(ffblk.ff_name + (_fstrlen(ffblk.ff_name) - 4), ".OV", 3))
		taralite();
	}
	done = findnext(&ffblk);
    }
    while (ndir > n) {
	ndir -= 1;
	chdir(names[ndir]);
	getcurdir(0, dizin + 3);
	explorelite();
	chdir("..");
	++dcount;
	if (dcount > 2000)
	    return;
    }
}

void showhlp(void)
{
    printf("\n--------------------------------------------------------------------------------");
    printf("ARA Anti-Virs Program Freeware v4.31  (C)1995, Blent EREN, All Rights Reserved");
    printf("--------------------------------------------------------------------------------");
    printf("\n  KULLANIM:  ARA [src:dizin] \n\
  RNEKLER:\n\
	     ARA                 <-Enter\n\
	     ARA  c:             <-Enter\n\
	     ARA  c:\\            <-Enter\n\
	     ARA  c:\\dos         <-Enter\n\
	     ARA  \\dos           <-Enter\n\
	     ARA  c: >ara.log    <-Enter\n");
    exit(2);
}

void self_check(void)
{
    FILE *in;
    unsigned char b1[128];
    unsigned char b2[128];
    int i;
    unsigned b;
    unsigned char rk;
    unsigned char *check;

    if ((in = fopen(self_name, "rb")) != NULL) {
	fread(b1, 1, 128, in);
	fseek(in, -257, 2);
	fread(&rk, 1, 1, in);
	fread(b2, 1, 128, in);
	fclose(in);
	for (i = 0; i < 128; i++)
	    b2[i] ^= rk;
	if (_fmemcmp((unsigned char far *) b1, (unsigned char far *) b2, 128)) {
	    printf("ARA.EXE dosyas deimi!\nu anda hafzada aktif bir ");
	    printf("virs olabilir.\nLtfen sistemi temiz bir disketle ap ");
	    printf("virs kontrol yapn.\n\n\a");
	    if (tunnel == 4) {
		setvect(0x21, old21);
		setvect(0x13, old13);
	    }
	    exit(99);
	}
    }
    check = (unsigned char *) MK_FP(_psp, 0);
    kod = peekb(0x0000, 0x04f1) ^ *check;
    b = peek(0x0000, 0x04f0);
    if (b != 0x4542) {
	printf("\nARA'nn pack rutini deimi!\n");
	printf("Kendi gvenliiniz iin program almayacak..\n");
	if (tunnel == 4) {
	    setvect(0x21, old21);
	    setvect(0x13, old13);
	}
	exit(99);
    }
    poke(0x0000, 0x04f0, 0);
}

void mainlite(int argc, char *argv[])
{
    struct REGPACK r;
    struct date d;
    int i;
    char uyari[] = "u anda kullandnz ARA program eskimi durumda.\n"
    "Virslerle etkili mcadele etmek istiyorsanz ltfen\n"
    "ARA'nn yeni bir versiyonunu kullann. evrenizdeki\n"
    "bbs'lerden ya da internet'ten yeni ARA versiyonlarn\n"
    "temin edebilirsiniz.\n\a";

    setcbrk(1);
    ctrlbrk(c_break);
    if ((argv[1][0] == '/') || (argv[1][0] == '?') || (argc > 3) || (argv[1][0] == '-'))
	showhlp();
    WindowsActive = windows(&MVer, &SVer);
    if (WindowsActive == NO_WIN) {
	old21 = getvect(0x21);
	tunnel21();
	new21 = getvect(0x21);
	old13 = getvect(0x13);
	tunnel13();
	new13 = getvect(0x13);
	if (new21 != old21)
	    tunnel = 4;
    }
    r.r_ax = 3;
    intr(0x10, &r);
    r.r_ax = 0x1110;
    r.r_bx = 0x1000;
    r.r_cx = 256;
    r.r_dx = 0;
    r.r_es = FP_SEG(arafont);
    r.r_bp = FP_OFF(arafont);
    intr(0x10, &r);
    _fstrcpy(self_name, argv[0]);
//    self_check();
    eski_surucu = getdisk();
    sprintf(eski_dizin, "%c:\\", eski_surucu + 'A');
    getcurdir(0, eski_dizin + 3);
    if (argc == 1) {
	surucu = 'A' + getdisk();
	getcurdir(0, dizin);
    } else {
	argv[1] = strupr(argv[1]);
	if (argv[1][1] == ':') {
	    if (argv[1][2] == '\\') {
		surucu = argv[1][0];
		_fstrcpy(dizin, &argv[1][2]);
	    } else {
		surucu = argv[1][0];
		_fstrcpy(dizin, "\\");
		_fstrcat(dizin, &argv[1][2]);
	    }
	} else {
	    if (argv[1][0] == '\\') {
		surucu = 'A' + getdisk();
		_fstrcpy(dizin, argv[1]);
	    } else {
		surucu = 'A' + getdisk();
		_fstrcpy(dizin, "\\");
		_fstrcat(dizin, argv[1]);
	    }
	}
	if (_chdrive(surucu - 'A' + 1)) {
	    printf("Src bulunamad.\n\r\a");
	    if (tunnel == 4) {
		setvect(0x21, old21);
		setvect(0x13, old13);
	    }
	    exit(2);
	}
	if (chdir(dizin)) {
	    printf("Dizin bulunamad.\n\r\a");
	    if (tunnel == 4) {
		setvect(0x21, old21);
		setvect(0x13, old13);
	    }
	    exit(2);
	}
    }
    clrscr();
    printf("--------------------------------------------------------------------------------");
    printf("ARA Anti-Virs Program Freeware v4.31  (C)1995, Blent EREN, All Rights Reserved");
    printf("--------------------------------------------------------------------------------");
    getdate(&d);
    if ((d.da_year == 1997 && d.da_mon > 8) || d.da_year > 1997 || d.da_year < 1997)
	puts(uyari);
    tcount = vcount = fcount = dcount = ndir = sormadan = buldu = pcount = 0;
    boot_taralite();
    explorelite();
    setdisk(eski_surucu);
    chdir(eski_dizin);
    clreol();
    for (i = 0; i < sizeof(bufr); i++)
	bufr[i] ^= 0x03;
    if (vcount) {
	textcolor(15 + BLINK);
	cprintf("\n\r\n\rSistemde virs bulundu !!!\n\r\a");
	if (tunnel == 4) {
	    setvect(0x21, old21);
	    setvect(0x13, old13);
	}
	exit(3);
    }
    if (pcount) {
	textcolor(15 + BLINK);
	cprintf("\n\r\n\rSistemde pheli dosya bulundu !!!\n\r\a");
	if (tunnel == 4) {
	    setvect(0x21, old21);
	    setvect(0x13, old13);
	}
	exit(4);
    }
    if (tunnel == 4) {
	setvect(0x21, old21);
	setvect(0x13, old13);
    }
    exit(1);
}


void main(int argc, char *argv[])
{
    struct REGPACK re;
    struct ffblk ffblk;
    struct date d;
    int done;

    Argv = argv;
    argc = argc;
    if (argc != 1)
	mainlite(argc, argv);

    re.r_ax = 3;
    intr(0x10, &re);
    re.r_ax = 0x1110;
    re.r_bx = 0x1000;
    re.r_cx = 256;
    re.r_dx = 0;
    re.r_es = FP_SEG(arafont);
    re.r_bp = FP_OFF(arafont);
    intr(0x10, &re);
    _fstrcpy(self_name, argv[0]);
//    self_check();
    WindowsActive = windows(&MVer, &SVer);
    if (WindowsActive == NO_WIN) {
	old21 = getvect(0x21);
	tunnel21();
	new21 = getvect(0x21);
	old13 = getvect(0x13);
	tunnel13();
	new13 = getvect(0x13);
	if (new21 != old21)
	    tunnel = 4;
    }
    harderr(handler);
    b = _fstrlen(argv[0]);
    for (j = b - 1; j > 0; j--)
	if (argv[0][j] == '\\')
	    break;
    k = 0;
    j++;
    for (; j < b; j++) {
	p_ismi[k] = argv[0][j];
	k++;
    }
    p_ismi[k] = '\0';
    eski_surucu = getdisk();
    sprintf(eski_dizin, "%c:\\", eski_surucu + 'A');
    getcurdir(0, eski_dizin + 3);
    done = findfirst("ara_ayar.cfg", &ffblk, 0);
    if (!done) {
	tempfp = fopen("ara_ayar.cfg", "rb");
	fread(&ozet, 1, 1, tempfp);
	fread(&sil, 1, 1, tempfp);
	fread(&addcrc, 1, 1, tempfp);
	fread(&delcrc, 1, 1, tempfp);
	fread(&usecrc, 1, 1, tempfp);
	fclose(tempfp);
    }
    if (ozet)
	SetCommandToggle(&MainMenu, ID_OZET);
    if (sil)
	SetCommandToggle(&MainMenu, ID_SIL);
    if (addcrc)
	SetCommandToggle(&MainMenu, ID_ADDCRC);
    if (delcrc)
	SetCommandToggle(&MainMenu, ID_REMOVECRC);
    if (usecrc)
	SetCommandToggle(&MainMenu, ID_CHKCRC);

    b = _fstrlen(argv[0]);
    for (j = b - 1; j > 0; j--)
	if (argv[0][j] == '\\')
	    break;
    j++;
    for (k = 0; k < j; k++)
	undo[k] = recover[k] = argv[0][k];
    undo[j] = recover[j] = '\0';
    _fstrcat(undo, "UNDO.DAT");
    _fstrcat(recover, "ARABOOT.DAT");
    if (!init_messages())
	return;
    if (!LoadConfig())
	cfg.ScreenLines = SCREENHEIGHT;
    aramain = CreateWindow(APPLICATION,
			   "   ARA Anti-Virs Program v4.31 - (C)1995 Blent EREN, All Rights Reserved.",
			   0, 0, -1, -1,
			   &MainMenu,
			   NULL,
			   ARAProc,
			   HASBORDER |
			   HASSTATUSBAR
	);
    LoadHelpFile(DFlatApplication);
    SendMessage(aramain, SETFOCUS, TRUE, 0);
    getdate(&d);
    if ((d.da_year == 1997 && d.da_mon > 8) || d.da_year > 1997 || d.da_year < 1997)
	MessageBox2("UYARI",
		  "u anda kullandnz ARA program eskimi durumda.\n"
		 "Virslerle etkili mcadele etmek istiyorsanz ltfen\n"
		  "ARA'nn yeni bir versiyonunu kullann. evrenizdeki\n"
		"bbs'lerden ya da internet'ten yeni ARA versiyonlarn\n"
		    "temin edebilirsiniz.");
    while (dispatch_message());
    setdisk(eski_surucu);
    chdir(eski_dizin);
    for (i = 0; i < sizeof(bufr); i++)
	bufr[i] ^= 0x03;
    textmode(2);
    textmode(3);
    if (tunnel == 4) {
	setvect(0x21, old21);
	setvect(0x13, old13);
    }
}
